require 'spec_helper'
require 'rails'
require 'hawkei/plugins/rails/middleware_data'

describe Hawkei::Plugins::Rails::MiddlewareData do

  let(:middleware) { Hawkei::Plugins::Rails::MiddlewareData }

  describe '#store_data' do
    let(:request) do
      double('request',
        env: {
          'action_dispatch.request_id' => '42a'
        }
      )
    end

    context 'blank store' do
      before { middleware.store_data(request) }

      let(:expected) {{
        request: {
          id: '42a'
        }
      }}

      it { expect(Hawkei::Store.store).to match(expected) }
    end

    context 'update the store' do
      before do
        Hawkei::Store.set(:request, { xhr: false })
      end
      before { middleware.store_data(request) }

      let(:expected) {{
        request: {
          id: '42a',
          xhr: false
        }
      }}

      it { expect(Hawkei::Store.store).to match(expected) }
    end
  end
end
