require 'spec_helper'

describe Hawkei::Watcher do

  describe '#create' do
    let(:response) { double('Hawkei::Request', body: "{\"object\":\"watcher\",\"id\":1}") }
    before { expect(Hawkei::Request).to receive(:execute).and_return(response) }

    subject(:create) { Hawkei::Watcher.create(template_flow: 'My Hawkei', expected_times: 42) }

    it { is_expected.to be_successful }
    it { expect(create.id).to eq(1) }
  end

  describe '#delete' do
    let(:response) { double('Hawkei::Request', body: "{\"object\":\"watcher\",\"id\":1}") }
    before { expect(Hawkei::Request).to receive(:execute).and_return(response) }

    subject(:delete) { Hawkei::Watcher.delete(1) }

    it { is_expected.to be_successful }
    it { expect(delete.id).to eq(1) }
  end

end
